<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00015000ApontamentoRecursosFactory {
    
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
     /**
      * Valida o campo tipo no banco
     */
    public function validaçãoDeCampoTipo($params){
        $sql = "SELECT  IDTIPOAPONTAMENTO
                      FROM FCT_APONTAMENTOAPROPAGEN
                               WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                               AND NRORG = :NRORG
                   AND DTINCLUSAO = (SELECT MAX(DTINCLUSAO)
                                        FROM FCT_APONTAMENTOAPROPAGEN
                               WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                               AND NRORG = :NRORG)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
     /**
     * Retorna as horas apropriada para setar no campo Inicio da tela
     */
    public function validaHorarios($params){
        $sql = "SELECT DTHRFIMCIOAPONT
                  FROM FCT_APONTAMENTOAPROPAGEN
                 WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                   AND NRORG              = :NRORG
                   AND  DTINCLUSAO        = (SELECT MAX(DTINCLUSAO)
                                               FROM FCT_APONTAMENTOAPROPAGEN
                                              WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                                                AND NRORG              = :NRORG)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    /**
     * Retorna as horas apropriada para setar no campo Inicio da tela
     */
    public function verificarApontamento($params){
        $sql = "SELECT SUM(QTTEMPOAPONT) AS LANCADO
                  FROM FCT_APONTAMENTOAPROPAGEN
                 WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                   AND NRORG              = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    } 
     /*
    * Atualizando no banco o campo da tabela com a situação de apontamento confirmada
    */
    public function atualizarSituacao($params){
        $sql = "UPDATE FCT_APROPAGENDAMENTO
                    SET IDSTATUSAPROPRIACAO = 3
                    WHERE NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
                    AND NRORG              = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}

?>