/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCREDITO                                              */
/* Tabela : TPCREDBANC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 23/02/2006 - ARNALDO COUTINHO BRITO JNIOR                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOCREDITO' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOCREDITO
GO

CREATE TRIGGER DTULTATU_TIPOCREDITO
ON TPCREDBANC
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TPCREDBANC', null, 'CDTPCREDBANC=' + CDTPCREDBANC + ';',                                     GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE TPCREDBANC
      SET DTULTATUTPCR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TPCREDBANC.CDTPCREDBANC,0) = ISNULL(INSERTED.CDTPCREDBANC,0)) AND                         (ISNULL(TPCREDBANC.CDCLASSFINA,0 ) = ISNULL(INSERTED.CDCLASSFINA,0 )) AND
            (ISNULL(TPCREDBANC.CDHISTPADR,0  ) = ISNULL(INSERTED.CDHISTPADR,0  )) AND
            (ISNULL(TPCREDBANC.CDCONTCTBL,0  ) = ISNULL(INSERTED.CDCONTCTBL,0  )) AND
            (ISNULL(TPCREDBANC.DSTPCREDBANC,0) = ISNULL(INSERTED.DSTPCREDBANC,0)) AND
            (ISNULL(TPCREDBANC.IDCTBLCRBANC,0) = ISNULL(INSERTED.IDCTBLCRBANC,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOCREDITO','4.11.072';
GO

