<?php
namespace Teknisa\Model\Teknisa\Repositories;

use Teknisa\Libs\Util\Utilities;
use Teknisa\Model\Teknisa\Entities;
use Doctrine\DBAL\Connection;


class OmProdutoOrg extends \Doctrine\ORM\EntityRepository {

    public function obtemTodos($nrOrgId, $conditions){
        $query = <<<SQL
		SELECT *
          FROM (SELECT PO.ID, PO.NRORG_ID, PO.IDATIVO, PO.NRPRODUTO_ID,
                       PO.CDAPPNOTIF, PO.DSCHAVENOTIF, PR.NMPRODUTO, PR.DSURL_JSON_MENU,
                       PO.DSURLREDIRECT, PO.IDPRODUTOEXCLUSIVO, PO.DSURLACESSO, PO.DTVALARQPERS
                  FROM OM_PRODUTO_ORG PO
            INNER JOIN OM_PRODUTO PR ON PR.ID = PO.NRPRODUTO_ID
            INNER JOIN PRODUCT EXPROD ON EXPROD.ID = PR.NREXTERNAL_PRODUCT_ID
	        INNER JOIN PROJECT EXPROJ ON EXPROJ.ID = EXPROD.PROJECT_ID
                 WHERE PO.NRORG_ID = :NRORG_ID
                   AND EXPROJ.PRODUCT_TYPE = 'C'
              ORDER BY PO.ID)
         WHERE 1 = 1
        $conditions
SQL;

        $params = array( 'NRORG_ID' => $nrOrgId );
        $produtoOrgs = $this->getEntityManager()->getConnection()->fetchAll($query, $params);

        foreach($produtoOrgs as &$produtoOrg){
            $produtoOrg['ID'] = intval($produtoOrg['ID']);
        }

        return $produtoOrgs;
    }

    public function findProductOrg($id,$product_org){
        $query = <<<SQL
        SELECT PRORG.DTVALARQPERS ,PRORG.ID AS PRODUCT_ORG, PRORG.DSCHAVENOTIF, PRORG.CDAPPNOTIF, PROD.ID,
               PROD.NMPRODUTO, PROD.DSURL_JSON_MENU, PROD.IDSTATUS, PRORG.DSURLREDIRECT, PRORG.IDUTREDIRECTRC, 
               PRORG.IDPRODUTOASSISTANT, PRORG.IDUTASSMULTVER,
		       PROD.DTINCLUSAO, PROD.DTULTATU, OPERINC.NMOPERADOR AS NMOPERINCLUSAO,
		       OPERATU.NMOPERADOR AS NMOPERULTATU, PROD.NREXTERNAL_PRODUCT_ID, PRORG.IDPRODUTOSAAS, 
               PRORG.IDPRODUTOEXCLUSIVO, PRORG.DSURLACESSO
            FROM OM_PRODUTO_ORG  PRORG
            INNER JOIN OM_PRODUTO PROD ON PROD.ID = PRORG.NRPRODUTO_ID
            LEFT JOIN OPERADOR OPERINC ON (OPERINC.CDOPERADOR = PROD.CDOPERINCLUSAO)
            LEFT JOIN OPERADOR OPERATU ON (OPERATU.CDOPERADOR = PROD.CDOPERULTATU)
         WHERE PRORG.ID = :product_org AND PROD.ID = :productid
SQL;
        $params = array(
                'product_org' => $product_org,
                'productid' => $id
            );

        return $produtoOrgs = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function obtemTodosNaoIncluidos($organizationId, $conditions){//aaaaaaa
        $query = <<<SQL
        SELECT *
          FROM (SELECT OP.ID, OP.NMPRODUTO, OP.IDPRODUTOSAAS,
                       CASE OP.IDPRODUTOSAAS
                       WHEN :SAAS        THEN 'Exclusivamente SAAS'
                       WHEN :NAOSAAS     THEN 'Exclusivamente NÃO SAAS'
                       WHEN :ORGANIZACAO THEN 'Assume identificador da Organização'
                        END AS PRODSTATUS
                  FROM OM_PRODUTO OP
	        INNER JOIN PRODUCT EXPROD ON EXPROD.ID = OP.NREXTERNAL_PRODUCT_ID
	        INNER JOIN PROJECT EXPROJ ON EXPROJ.ID = EXPROD.PROJECT_ID
                 WHERE OP.ID NOT IN (SELECT OPG.NRPRODUTO_ID
                                       FROM OM_PRODUTO_ORG OPG
                                      WHERE OPG.NRORG_ID = :NRORG_ID)
                   AND OP.IDSTATUS = 'A'
                   AND EXPROJ.PRODUCT_TYPE = 'C'
                 ORDER BY OP.ID)
         WHERE 1 = 1
        $conditions
SQL;
        $param = array( 'NRORG_ID' => $organizationId,
                        'SAAS' => Entities\OmProduto::PRODUTO_SAAS,
                        'NAOSAAS' => Entities\OmProduto::PRODUTO_NAO_SAAS,
                        'ORGANIZACAO' => Entities\OmProduto::HERDA_ORGANIZACAO,
                    );
        $produtoOrgs = $this->getEntityManager()->getConnection()->fetchAll($query, $param);

        foreach($produtoOrgs as &$produtoOrg){
            $produtoOrg['ID'] = intval($produtoOrg['ID']);
        }
        return $produtoOrgs;
    }

    public function getOrgProductByExternalProductIdAndProductNrOrgId($externalProductId, $nrOrg){
        $query = <<<SQL
		SELECT OMP.ID
		  FROM OM_PRODUTO OMP
	INNER JOIN OM_PRODUTO_ORG OPO ON OPO.NRPRODUTO_ID = OMP.ID
		 WHERE OMP.NREXTERNAL_PRODUCT_ID = :EXTERNAL_PRODUCT_ID
		   AND OPO.NRORG_ID = :NRORG
SQL;
        $params = array(
            'EXTERNAL_PRODUCT_ID' => $externalProductId,
            'NRORG' => $nrOrg
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getOrgCommercialProductByNrOrgId($nrParcNegocio) {
        $query = <<<SQL
                SELECT OMP.ID AS NRPRODUTO, OMP.NMPRODUTO,
                       OMP.NREXTERNAL_PRODUCT_ID, OPO.ID AS NRPRODUTO_ORG,
                       PRO.VERSION_CHECK_TYPE, PRO.URL_WEBSERVICE,
                       OMP.IDPRODUTOSAAS, OPO.IDPRODUTOSAAS AS IDPRODUTOORGSAAS, ORG.IDORGSAAS, PRJ.PRODUCT_TYPE AS PRODUCT_TYPE
                  FROM OM_PRODUTO_ORG OPO
            INNER JOIN OM_PRODUTO OMP ON OPO.NRPRODUTO_ID = OMP.ID
            INNER JOIN ORGANIZACAO ORG ON ORG.NRORG = OPO.NRORG_ID
            INNER JOIN PRODUCT PRO ON PRO.ID = OMP.NREXTERNAL_PRODUCT_ID
            INNER JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'C'
                 WHERE ORG.NRPARCNEGOCIO = $nrParcNegocio
SQL;
        return $query;
    }

    public function getOrgInternalProductByNrOrgId($externalCode) {
        $query = <<<SQL
       SELECT DISTINCT OMP.ID AS NRPRODUTO, OMP.NMPRODUTO,
                       OMP.NREXTERNAL_PRODUCT_ID, NULL AS NRPRODUTO_ORG,
                       PRO.VERSION_CHECK_TYPE, PRO.URL_WEBSERVICE,
                       OMP.IDPRODUTOSAAS, NULL AS IDPRODUTOORGSAAS, ORG.IDORGSAAS, PRJ.PRODUCT_TYPE AS PRODUCT_TYPE
                  FROM PRODUCT PRO
            INNER JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'I'
            INNER JOIN OM_PRODUTO OMP ON PRO.ID = OMP.NREXTERNAL_PRODUCT_ID
            INNER JOIN PRODUCT_SERVER PRS ON PRS.PRODUCT_ID = PRO.ID AND PRS.USETYPE = 'P'
            INNER JOIN SERVER SER ON SER.ID = PRS.SERVER_ID
            INNER JOIN RESOURCE_T RES ON SER.RESOURCE_T_ID = RES.ID AND RES.EXTERNAL_CODE = '$externalCode'
            INNER JOIN CLIENTE CLI ON CLI.CDCLIENTE = RES.EXTERNAL_CODE
            INNER JOIN ORGANIZACAO ORG ON ORG.NRORG = CLI.NRORG
SQL;
        return $query;
    }

    public function getOrgAllProductByNrOrgId($productType, $nrParcNegocio, $externalCode, $filterQuery, $offset, $limit) {
        $queryCommercialProduct = $this->getOrgCommercialProductByNrOrgId($nrParcNegocio);
        $queryInternalProduct = $this->getOrgInternalProductByNrOrgId($externalCode);
        if($productType == 'C'){
            $finalQuery = $queryCommercialProduct;
        }else if ($productType == 'I'){
            $finalQuery = $queryInternalProduct;
        }else if($productType == 'B'){
            $finalQuery = $queryCommercialProduct . " UNION " . $queryInternalProduct;
        }
        $query = <<<SQL
        SELECT *
          FROM ($finalQuery)
         WHERE 1 = 1
		       $filterQuery
	  ORDER BY NMPRODUTO
SQL;

        $params = array(
            'NRPARCNEGOCIO' => $nrParcNegocio,
            'EXTERNALCODE' => $externalCode
        );
        $query  = self::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public static function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $limit . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $limit;
            }
        }
        return $query;
    }

    /**
     * @param $nrOrg
     * @param $productId
     * @return array
     */
    public function getURLRedirectByNrorgAndProductId($nrOrg, $productId){
        $query = "SELECT OO.DSURLREDIRECT,
                         DECODE(OG.IDUTREDIRECTRC, 'S', OG.IDUTREDIRECTRC, OO.IDUTREDIRECTRC) AS IDUTREDIRECTRC
                    FROM OM_PRODUTO_ORG OO
                    JOIN OM_PRODUTO OP ON OP.ID = OO.NRPRODUTO_ID
               LEFT JOIN OM_PARAM_ORG OG ON OG.NRORG = OO.NRORG_ID
                   WHERE OP.NREXTERNAL_PRODUCT_ID = :PRODUCT_ID
                     AND OO.NRORG_ID = :NRORG";

        $params = array( 'NRORG' => $nrOrg, 'PRODUCT_ID' => $productId );
        $result = $this->getEntityManager()->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    /**
     * @param $productId
     * @param $productOrgId
     * @param $filters
     * @return array
     */
    public function findProductElement($productId, $productOrgId, $filters)
    {
        $query = "
             SELECT *
              FROM (SELECT PE.ID, PE.LABEL, PE.UNIQUE_ID, PE.NRORDEM,
                           PE.NRPRODUTO_ID, PE.PARENT_ID, EP.LABEL AS PARENT_LABEL,
                           TO_CHAR(OE.DTVALIDADE, 'DD/MM/YYYY') AS DTVALIDADE
                      FROM OM_PRODUTO_ELEMENTO PE
                      JOIN OM_PRODUTO_ORG_ELEMENTO OE ON OE.NRPRODUTO_ELEMENTO_ID = PE.ID
                                                     AND OE.NRPRODUTO_ORG_ID = :NRPRODUTO_ORG_ID
                      JOIN OM_PRODUTO OP ON OP.ID = PE.NRPRODUTO_ID
                 LEFT JOIN OM_PRODUTO_ELEMENTO EP ON EP.ID = PE.PARENT_ID
                     WHERE OP.NREXTERNAL_PRODUCT_ID = :PRODUCT_ID
                  ORDER BY PE.NRORDEM)
             WHERE 1 = 1
             $filters";

        $params = array(
            'PRODUCT_ID' => $productId,
            'NRPRODUTO_ORG_ID' => $productOrgId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    /**
     * @param $productId
     * @param $productOrgId
     * @param $elementIds
     * @return array
     */
    public function findProductElementsToDeleteContract($productId, $productOrgId, $elementIds)
    {
        $query = "
             SELECT PE.ID, PE.LABEL, PE.UNIQUE_ID,
                    PE.NRPRODUTO_ID, PE.PARENT_ID
               FROM OM_PRODUTO_ELEMENTO PE
               JOIN OM_PRODUTO_ORG_ELEMENTO OE ON OE.NRPRODUTO_ELEMENTO_ID = PE.ID
                                              AND OE.NRPRODUTO_ORG_ID = :NRPRODUTO_ORG_ID
               JOIN OM_PRODUTO OP ON OP.ID = PE.NRPRODUTO_ID
              WHERE OP.ID = :PRODUCT_ID
                AND PE.UNIQUE_ID NOT IN (:ELEMENT_IDS)
                AND EXISTS (SELECT ID
                              FROM OM_PROD_ORG_ELEMENTO_CONTRATO
                             WHERE NRPRODUTO_ORG_ELEMENTO_ID = OE.ID)";

        $params = array(
            'PRODUCT_ID'       => $productId,
            'NRPRODUTO_ORG_ID' => $productOrgId,
            'ELEMENT_IDS'      => $elementIds
        );
        $paramsTypes = array(
            'ELEMENT_IDS' => Connection::PARAM_STR_ARRAY
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params, $paramsTypes);
    }

}
